## Copyright (C) 2009, 2010   Lukas F. Reichlin
##
## This file is part of LTI Syncope.
##
## LTI Syncope is free software: you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation, either version 3 of the License, or
## (at your option) any later version.
##
## LTI Syncope is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.
##
## You should have received a copy of the GNU General Public License
## along with LTI Syncope.  If not, see <http://www.gnu.org/licenses/>.

## -*- texinfo -*-
## @deftypefn {Function File} {[@var{a}, @var{b}, @var{c}, @var{d}, @var{tsam}] =} ssdata (@var{sys})
## Access state-space model data.
## @end deftypefn

## Author: Lukas Reichlin <lukas.reichlin@gmail.com>
## Created: September 2009
## Version: 0.2

function [a, b, c, d, tsam] = ssdata (sys)

  if (! isa (sys, "ss"))
    sys = ss (sys);
  endif

  [a, b, c, d, e] = __sys_data__ (sys);

  if (! isempty (e))
    if (rcond (e) < eps)  # check for singularity
      error ("ss: ssdata: descriptor matrice ""e"" singular");
    endif

    a = e \ a;
    b = e \ b;
  endif

  tsam = sys.tsam;

endfunction